#include <stdio.h>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <algorithm>

using namespace std;
const int MAX_INT = 1<<30;

struct Node{
    int mn,mx;
    int sum,n;
    int ltime,rtime;
};

void build(vector<Node> &tree,vector<int> &time,vector<int> &value, int l,int r,int v){
    Node ans;
    //printf("%d %d\n",l,r);
    if(l==r){
        ans.mn = value[l];
        ans.mx = value[l];
        ans.sum = value[l];
        ans.n = 1;
        ans.ltime = time[l];
        ans.rtime = time[l];
        tree[v] = ans;
        return;
    }
    int mid = (l+r)/2;
    build(tree,time,value,l,mid,2*v);
    build(tree,time,value,mid+1,r,2*v+1);
    Node left = tree[2*v];
    Node right = tree[2*v+1];
    ans.mn = min(left.mn,right.mn);
    ans.mx = max(left.mx,right.mx);
    ans.sum = left.sum+right.sum;
    ans.n = left.n + right.n;
    ans.ltime = left.ltime;
    ans.rtime = right.rtime;
    tree[v] = ans;
    return;
}


int reach;


int fmin(vector<Node> &tree,int l,int r,int ltime,int rtime,int v){
    //printf("%d %d : %d %d || %d %d\n",l,r,ltime,rtime,tree[v].ltime, tree[v].rtime);
    if(tree[v].ltime>rtime || tree[v].rtime<ltime)
        return MAX_INT;
    if(tree[v].ltime>=ltime && tree[v].rtime<=rtime){
        reach += tree[v].n;
        return tree[v].mn;
    }
    if(l==r){
        reach += tree[v].n;
        return tree[v].mn;
    }
    int mid = (l+r)/2;
    
    int a1 = fmin(tree,l,mid,max(ltime,tree[v].ltime),min(rtime,tree[v].rtime),2*v);
    int a2 = fmin(tree,mid+1,r,max(ltime,tree[v].ltime),min(rtime,tree[v].rtime),2*v+1);
    
    return min(a1,a2);
}

int fmax(vector<Node> &tree,int l,int r,int ltime,int rtime,int v){
    //printf("%d %d : %d %d || %d %d\n",l,r,ltime,rtime,tree[v].ltime, tree[v].rtime);
    
    if(tree[v].ltime>rtime || tree[v].rtime<ltime)
        return -MAX_INT;
    if(tree[v].ltime>=ltime && tree[v].rtime<=rtime){
        reach += tree[v].n;
        return tree[v].mx;
    }
    if(l==r){
        reach += tree[v].n;
        return tree[v].mx;
    }
    int mid = (l+r)/2;
    
    int a1 = fmax(tree,l,mid,max(ltime,tree[v].ltime),min(rtime,tree[v].rtime),2*v);
    int a2 = fmax(tree,mid+1,r,max(ltime,tree[v].ltime),min(rtime,tree[v].rtime),2*v+1);
    
    return max(a1,a2);
}

pair<long long,int> fsum(vector<Node> &tree,int l,int r,int ltime,int rtime,int v){
    //printf("%d %d : %d %d || %d %d\n",l,r,ltime,rtime,tree[v].ltime, tree[v].rtime);
    if(tree[v].ltime>rtime || tree[v].rtime<ltime)
        return make_pair(0ll,0);
    if(tree[v].ltime>=ltime && tree[v].rtime<=rtime){
        reach += tree[v].n;
        return make_pair(tree[v].sum,tree[v].n);
    }
    
    if(l==r){
        reach += tree[v].n;
        return make_pair(tree[v].sum, tree[v].n);
    }
    int mid = (l+r)/2;
    
    pair<long long,int> a1 = fsum(tree,l,mid,max(ltime,tree[v].ltime),min(rtime,tree[v].rtime),2*v);
    pair<long long,int> a2 = fsum(tree,mid+1,r,max(ltime,tree[v].ltime),min(rtime,tree[v].rtime),2*v+1);
    
    return make_pair(a1.first+a2.first, a1.second+a2.second);
}

int main(){
    //freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
    ios::sync_with_stdio(false);
    int n;
    while(cin>>n){
        vector<int> time(n),value(n);
        for(int i=0;i<n;i++)
            cin >> time[i] >> value[i];
        
        vector<Node> tree(4*n);
        build(tree,time,value,0,n-1,1);
        int m;
        cin >> m;
        for(int k=0;k<m;k++){
            string lg,fnc;
            int sec;
            cin >> lg >> fnc >> sec;
            int ans = 0;
            for(int i=1;i<n;i++){
                double res;
                reach = 0;
                if(fnc=="min"){
                    res = fmin(tree,0,n-1,time[i]-sec,time[i]-1,1);
                    
                    //cout << res << endl;
                }else if(fnc=="avg"){
                    pair<long long,int> lres = fsum(tree,0,n-1,time[i]-sec,time[i]-1,1);
                    if(lres.second==0)
                        res = 0;
                    else
                        res = lres.first/(double)lres.second;
                    //cout << res << " " <<value[i] << endl;
                }else if(fnc=="max"){
                    res = fmax(tree,0,n-1,time[i]-sec,time[i]-1,1);
                    //cout << res << " " <<value[i] << endl;
                }
                if(reach==0)
                    continue;
                if(lg=="lt"){
                    ans+=(value[i]<res)?1:0;
                    //cout << value[i] << " " << res << endl;
                    //cout << "!! " << ans << " " << i << endl;
                }else{
                    ans+=(value[i]>res)?1:0;
                }
            }
            cout << ans << endl;
            //cout << endl;
        }
    }
    return 0;
}
